'Compilable Example:
#Compile Exe "gbcodewords.exe"
#Dim All
%Unicode = 1
#Include "Win32API.inc"

#Resource Icon logo "images\logo.ico"
#Resource Icon xopen "images\open.ico"
#Resource Icon xclear "images\clear.ico"
#Resource Icon xreload "images\reload.ico"
#Resource Icon xfont "images\font.ico"
#Resource Icon xhelp "images\help.ico"
#Resource Icon xsort "images\sort.ico"
#Resource Icon xunique "images\unique.ico"
#Resource Icon xnumbers "images\numbers.ico"
#Resource Icon xcase "images\case.ico"

Enum Equates Singular
   IDC_TextIn  = 500
   IDC_TextOut
   IDC_Toolbar
   IDT_Open
   IDT_Clear
   IDT_Reload
   IDT_Extract
   IDT_Sort
   IDT_Unique
   IDT_Font
   IDT_Numbers
   IDT_CaseSensitive
   IDT_Help

   IDM_Sep
   IDM_Cut
   IDM_Copy
   IDM_CopyAll
   IDM_Paste
   IDM_Delete
   IDM_Clear
End Enum

$Ver = "1.0"

Global hDlg,hFont,hFontA,hToolbar,ghHook,hContext As Dword
Global FileName, FontName As WStringZ * %Max_Path
Global AllowNumbers, CaseSensitive, FontSize, FontAttr, OldProc As Long

Function PBMain() As Long
   Local temp$, style&
   style& = %WS_Child Or %WS_Visible Or %ES_MultiLine Or %WS_VScroll Or %ES_AutoHScroll _
      Or %WS_HScroll Or %ES_AutoVScroll Or %ES_WantReturn Or %ES_NoHideSel Or %WS_TabStop
   temp$ = "Sub MySub" + $CrLf + "   s += " + $Dq + "text" + $Dq + $CrLf + "   Call MyFunction 'comment" + $CrLf + "End Sub"
   Dialog New Pixels, 0, "gbCodeWords  v" + $ver,300,300,505,230, %WS_OverlappedWindow To hDlg
   Dialog Set Icon hDlg, "logo"
   CreateToolbar
   Control Add TextBox, hDlg, %IDC_TextIn,temp$, 10,55,240,190,style&, %WS_Ex_ClientEdge
   Control Add TextBox, hDlg, %IDC_TextOut,"<output>", 260,55,240,190,style&, %WS_Ex_ClientEdge
   Dialog Show Modal hDlg Call DlgProc
End Function

CallBack Function DlgProc() As Long
   Local temp$, w,h As Long
   Local PTT As TooltipText Ptr, nmtb As TBNotify Ptr, rc As Rect
   Select Case Cb.Msg
      Case %WM_InitDialog
         OldProc = SetWindowLong(GetDlgItem(hDlg, %IDC_TextIn), %GWL_WndProc, CodePtr(NewProc))  'subclass
         OldProc = SetWindowLong(GetDlgItem(hDlg, %IDC_TextOut), %GWL_WndProc, CodePtr(NewProc))  'subclass
         CreateCustomContextMenu
         BuildAcceleratorTable
         settings_INI "get"
         SetMenusAndToolbar
         Dialog Set Text hDlg, "gbCodeWords  v" + $ver + Space$(10) + FileName
         Font New "Tahoma", 10, 0 To hFontA
         Control Set Font hDlg, %IDC_Toolbar, hFontA
         Font New FontName, FontSize, FontAttr To hFont
         Control Set Font hDlg, %IDC_TextIn, hFont
         Control Set Font hDlg, %IDC_TextOut, hFont
         Control Post hDlg, %IDC_TextIn, %EM_SetSel, 0,0
      Case %WM_Command
         Select Case Cb.Ctl
            Case %IDT_Open
               SelectAndOpenFile
            Case %IDT_Clear
               Control Set Text hDlg, %IDC_TextIn, ""
               Control Set Text hDlg, %IDC_TextOut, ""
            Case %IDT_Reload
               LoadFileNameContent
            Case %IDT_Extract
               Control Get Text hDlg, %IDC_TextIn To temp$
               Control Set Text hDlg, %IDC_TextOut, ScanCode(temp$)
            Case %IDT_Sort
               SortOutput
            Case %IDT_Unique
               RemoveDuplicateWords
            Case %IDT_Font
               SelectMainFont
            Case %IDT_Help
               temp$ = "http://www.garybeene.com/sw/gbcodewords.htm"
               w = ShellExecute(hDlg, "Open", (temp$), $Nul, $Nul, %SW_ShowNormal)
            Case %IDT_CaseSensitive
               CaseSensitive = CaseSensitive Xor 1
               SetMenusAndToolbar
            Case %IDT_Numbers
               AllowNumbers = AllowNumbers Xor 1
               SetMenusAndToolbar

            Case %IDM_Cut     : SendMessage GetFocus, %WM_CUT, 0, 0
            Case %IDM_Copy    : SendMessage GetFocus, %WM_COPY, 0, 0
            Case %IDM_Paste   : SendMessage GetFocus, %WM_PASTE, 0, 0
            Case %IDM_Delete  : SendMessage GetFocus, %WM_CLEAR, 0, 0
            Case %IDM_CopyAll
               Control Get Text hDlg, IIf(GetFocus=GetDlgItem(hDlg,%IDC_TextIn),%IDC_TextIn,%IDC_TextOut) To temp$
               Clipboard Reset
               Clipboard Set Text temp$
            Case %IDM_Clear
               temp$ = ""
               Control Set Text hDlg, IIf(GetFocus=GetDlgItem(hDlg,%IDC_TextIn),%IDC_TextIn,%IDC_TextOut), temp$

         End Select
      Case %WM_Notify
         If Cb.NmCode = %TTN_GetDispInfo Then
            PTT = Cb.LParam
            @PTT.@lpszText = SetToolTips(Cb.NmId)
         End If
      Case %WM_Size
         Dialog Get Client hDlg To w,h
         Control Set Loc hDlg, %IDC_TextOut, w/2+5,55
         Control Set Size hDlg, %IDC_TextOut, w/2-15, h-65
         Control Set Size hDlg, %IDC_TextIn, w/2-10, h-65
      Case %WM_Destroy
         SetWindowLong GetDlgItem(hDlg, %IDC_TextIn), %GWL_WNDPROC, OldProc   'un-subclass
         SetWindowLong GetDlgItem(hDlg, %IDC_TextOut), %GWL_WNDPROC, OldProc   'un-subclass
         settings_INI "save"
   End Select
End Function

Function ScanCode(InText$) As String
  Local pd As CHARRANGE, Oldpd As CHARRANGE, tBuff As TEXTRANGE, temp$, tmp$
  Local xWord,Buf,UCBuf As String
  Local i,j,StopPos,lnLen As Long
  Local wFlag As Byte, Letter As Byte Ptr

  For J = 1 To ParseCount(InText$, $CrLf)
     Buf = Parse$(InText$,$CrLf,J)
     UCBuf = UCase$(Buf) + $Spc
     If Len(Trim$(UCBuf))=0 Then Iterate For
     lnLen = Len(UCBuf$)
     Letter = StrPtr(UCBuf) : wFlag = 0
     For I = 1 To Len(UCBuf)
        Select Case @Letter
           Case 97 To 122, 65 To 90, 192 To 214, 216 To 246, 248 To 255,35 To 38, 48 To 57, 63, 95 'word characters
              If wFlag = 0 Then wFlag = 1 : stopPos = I
           Case 34 'string quotes -> "
             stopPos = InStr(I + 1, UCBuf, Chr$(34)) 'Find match
             If stopPos Then
                StopPos = (StopPos - I + 1)
                I = I + StopPos
                Letter = Letter + StopPos
                wFlag = 0
             End If
           Case 39 'comment character -> '
              wFlag = 0
              Exit For
           Case Else  'word is ready
              If wFlag = 1 Then
                 xWord = Mid$(Buf, stopPos, I - stopPos)  'Get word
                 If xWord = "REM" Then wFlag = 0 : Exit For
                 wFlag = 0
                 '--- do something with the word here ---
                 If AllowNumbers Then
                    temp$ += $CrLf + xWord
                 Else
                    If InStr("0123456789",Left$(xWord,1))=0 Then temp$ += $CrLf + xWord
                 End If
                 '---------------------------------------
              End If
        End Select
        Incr Letter
     Next I
  Next J

  Function = LTrim$(temp$,$CrLf)
End Function

Sub Settings_INI(Task$)
   Local x,y As Long
   Local xResult, yResult, temp, INIFileName As WStringZ*%Max_Path
   INIFileName = Exe.Path$ + Exe.Name$ + ".ini"
   If Task$ = "get" Then
      'get dialog top/left from INI file and use to set Dialog location
      Getprivateprofilestring "All", "Left", "100", xResult, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Top", "100", yResult, %Max_Path, INIFileName
      Dialog Set Loc hDlg, Val(xResult), Val(yResult)   'left/top

      'get dialog width/height from INI file and use to set Dialog size
      GetPrivateProfileString "All", "Width", "500", xResult, %Max_Path, INIFileName
      GetPrivateProfileString "All", "Height", "300", yResult, %Max_Path, INIFileName
      Dialog Set Size hDlg,Val(xResult), Val(yResult)   'width/height

      'get value for string variables
      Getprivateprofilestring "All", "FontName", "Tahoma", FontName, %Max_Path, INIFileName
      Getprivateprofilestring "All", "FileName", "", FileName, %Max_Path, INIFileName

      'get value for numeric variables
      Getprivateprofilestring "All", "FontSize", "10", temp, %Max_Path, INIFileName:  FontSize = Val(temp)
      Getprivateprofilestring "All", "FontAttr", "0", temp, %Max_Path, INIFileName:  FontAttr = Val(temp)
      Getprivateprofilestring "All", "AllowNumbers", "0", temp, %Max_Path, INIFileName:  AllowNumbers = Val(temp)
      Getprivateprofilestring "All", "CaseSensitive", "0", temp, %Max_Path, INIFileName:  CaseSensitive = Val(temp)
   End If

   If Task$ = "save" Then
      'save dialog size/location unless minimized or maximized
      If IsFalse(IsIconic(hDlg) Or IsZoomed(hDlg)) Then
         Dialog Get Loc hDlg To x,y
         WritePrivateProfileString "All", "Left", Str$(x), INIFileName
         WritePrivateProfileString "All", "Top", Str$(y), INIFileName
         Dialog Get Size hDlg To x,y
         WritePrivateProfileString "All", "Width", Str$(x), INIFileName
         WritePrivateProfileString "All", "Height", Str$(y), INIFileName
      End If

      'save string variables
      WritePrivateProfileString "All", "FontName",FontName, INIFileName
      WritePrivateProfileString "All", "FileName",FileName, INIFileName

      'save numeric variables
      WritePrivateProfileString "All", "FontSize", Str$(FontSize), INIFileName
      WritePrivateProfileString "All", "FontAttr", Str$(FontAttr), INIFileName
      WritePrivateProfileString "All", "AllowNumbers", Str$(AllowNumbers), INIFileName
      WritePrivateProfileString "All", "CaseSensitive", Str$(CaseSensitive), INIFileName
   End If
End Sub

Function SetToolTips(cID As Long) As String
   Select Case cID         'or this:   @P.hdr.idFrom
      Case %IDT_Open          : Function = "Open Code File"
      Case %IDT_Clear         : Function = "Clear In/Out Content"
      Case %IDT_Reload        : Function = "Reload Content From File"
      Case %IDT_Extract       : Function = "Extract Words from Code List"
      Case %IDT_Sort          : Function = "Sort Word List and Show All Words"
      Case %IDT_Unique        : Function = "Sort Word List and Show Unique Words Only"
      Case %IDT_Font          : Function = "Select Font"
      Case %IDT_Numbers       : Function = "Allow Number Words"
      Case %IDT_CaseSensitive : Function = "Case Sensitive Sort/Unique Actions"
      Case %IDT_Help          : Function = "Online Help"
   End Select
End Function

Sub CreateToolbar
    Local hImageList As Dword
    Control Add Toolbar, hDlg, %IDC_Toolbar,"", 0,0,0,0,%TbStyle_Tooltips Or %TbStyle_Flat Or %WS_Child
    Control Handle hDlg, %IDC_Toolbar To hToolbar
    SendMessage hToolbar, %TB_SETEXTENDEDSTYLE, 0, %TBSTYLE_EX_DRAWDDARROWS

    ImageList New Icon 24,24,24,50 To hImageList
    ImageList Add Icon hImageList, "logo"      '1
    ImageList Add Icon hImageList, "xopen"     '2
    ImageList Add Icon hImageList, "xclear"    '3
    ImageList Add Icon hImageList, "xreload"   '4
    ImageList Add Icon hImageList, "xfont"     '5
    ImageList Add Icon hImageList, "xhelp"     '6
    ImageList Add Icon hImageList, "xunique"   '7
    ImageList Add Icon hImageList, "xsort"     '8
    ImageList Add Icon hImageList, "xnumbers"  '9
    ImageList Add Icon hImageList, "xcase"    '10
    Toolbar Set ImageList hDlg, %IDC_Toolbar, hImageList, 0

    Toolbar Add Button    hDlg, %IDC_Toolbar, 2,  %IDT_Open, %BTNS_Button, "Open"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 3,  %IDT_Clear, %BTNS_Button, "Clear"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 4,  %IDT_Reload, %BTNS_Button, "Reload"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button    hDlg, %IDC_Toolbar, 1,  %IDT_Extract, %BTNS_Button, "Extract"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 8,  %IDT_Sort, %BTNS_Button, "Sort"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 7,  %IDT_Unique, %BTNS_Button, "Unique"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button    hDlg, %IDC_Toolbar, 5,  %IDT_Font, %BTNS_Button, "Font"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 9,  %IDT_Numbers, %BTNS_Check, "Numbers"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 10,  %IDT_CaseSensitive, %BTNS_Check, "Case"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 6,  %IDT_Help,  %BTNS_Button, "Help"

End Sub

Sub SelectMainFont
   Local fName As String, fPoints, fStyle, fColor, CharSet, Style As Long, temp$
'   Style = %CF_ScreenFonts Or %CF_ForceFontExist Or %CF_NoScriptSel Or %CF_NoSimulations 'Or IIf(FixedPitch,%CF_FixedPitchOnly,0)
   Style = %CF_ForceFontExist Or %CF_NoScriptSel Or %CF_NoSimulations Or %CF_ScreenFonts 'Or %CF_FixedPitchOnly 'OR %CF_ScreenFonts Or
   ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(FontDialogProc), GetModuleHandle(""), GetCurrentThreadId)
   Display Font hDlg, 100,100, FontName, FontSize, FontAttr, Style To fName, fPoints, fStyle, fColor, CharSet
   UnhookWindowsHookEx ghHook
   If Len(fName) Then
      FontName = fName : FontSize = fPoints : FontAttr = fStyle
      Font New FontName, FontSize, FontAttr To hFont
      Control Set Font hDlg, %IDC_TextIn, hFont
      Control Set Font hDlg, %IDC_TextOut,  hFont
   End If
End Sub

Function FontDialogProc(ByVal nCode As Long, ByVal WParam As Long, ByVal LParam As Long) As Long
'   If Debug Then Txt.Print FuncName$ ... disabled by choice
    Local szTemp As WStringZ * %Max_Path, cw As CBT_CREATEWND Ptr, cst As CREATESTRUCT Ptr
    Function = CallNextHookEx(ByVal ghHook, ByVal nCode, ByVal WParam, ByVal LParam)
    If nCode < 0 Then Exit Function
    If nCode = %HCBT_ACTIVATE Then UnhookWindowsHookEx ghHook
    If nCode = %HCBT_CREATEWND Then
        cw = LParam         ' Get pointer to CBT_CREATEWND struct so we can...    TT: Nick Melnick
        cst = @cw.lpcs      ' get a pointer to the CREATESTRUCT struct
        GetClassName WParam, szTemp, %Max_Path      ' for each window / control as it is created
        If UCase$(szTemp) = "#32770" Then @cst.cy = @cst.cy - 165 : @cst.cx = @cst.cx - 10  'dialog
    End If
End Function

Sub LoadFileNameContent
   If IsFalse(IsFile(FileName)) Then
      sndPlaySound("MailBeep", %SND_Async)    'play sound once (in the background)
      Exit Sub
   End If
   Local temp$
   Open FileName For Binary As #1
   Get$ #1, Lof(1), temp$
   Close #1
   Control Set Text hDlg, %IDC_TextIn, temp$
End Sub

Function SelectAndOpenFile As Long
    Local startfolder$, filter$, startfile$, defaultext$, flags&, filevar$, countvar&
    filter$ = "Source Code (*.bas, *.inc)" + $Nul + "*.bas;*.inc" + $Nul
    startfolder$ = IIf$(IsFile(FileName), FileName, Exe.Path$)     'initial folder to be displayed
    startfile$ = (FileName)       'name to be used as initial selection
    flags& = %OFN_Explorer Or %OFN_FileMustExist Or %OFN_HideReadOnly
    Display Openfile hDlg, 100, 100, "", startfolder$, filter$, startfile$, defaultext$, flags& To filevar$, countvar&
    If Len(filevar$) Then
       FileName = filevar$
       Dialog Set Text hDlg, "gbCodeWords  v" + $ver + Space$(10) + FileName
       LoadFileNameContent
    End If
End Function

Sub SortOutput
   Local temp$
   Control Get Text hDlg, %IDC_TextOut To temp$
   Dim WordList(ParseCount(temp$,$CrLf)-1) As String
   Parse temp$,WordList(),$CrLf
   If CaseSensitive Then
      Array Sort WordList(0)
   Else
      Array Sort WordList(0), Collate UCase
   End If
   Control Set Text hDlg, %IDC_TextOut, Join$(WordList(),$CrLf)
End Sub

Sub RemoveDuplicateWords
   Local temp$, i,iCount As Long
   Control Get Text hDlg, %IDC_TextOut To temp$
   Dim WordList(ParseCount(temp$,$CrLf)-1) As String
   Parse temp$,WordList(),$CrLf
   If CaseSensitive Then
      Array Sort WordList(0)
   Else
      Array Sort WordList(0), Collate UCase
   End If
   For i = UBound(WordList) To 1 Step -1
      If CaseSensitive Then
         If WordList(i) = WordList(i-1) Then Array Delete WordList(i) : Incr iCount
      Else
         If LCase$(WordList(i)) = LCase$(WordList(i-1)) Then Array Delete WordList(i) : Incr iCount
      End If
   Next i
   ReDim Preserve WordList(UBound(WordList)-iCount)
   Control Set Text hDlg, %IDC_TextOut, Join$(WordList(),$CrLf)
End Sub

Sub SetMenusAndToolbar
   'Toolbar Buttons
    Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Numbers, IIf(AllowNumbers,%TBState_Checked,0) Or %TBState_Enabled
    Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_CaseSensitive, IIf(CaseSensitive,%TBState_Checked,0) Or %TBState_Enabled

   'Menus
'    Menu Set State hSettings, ByCmd %IDM_AllowNumbers, AllowNumbers * %MFS_Checked Or %MFS_Enabled
End Sub

Sub BuildAcceleratorTable
   Local cc As Long, ac() As ACCELAPI, hAccelerator As Dword  ' for keyboard accelator table values
   Dim ac(7)
   ac(cc).fvirt = %FVIRTKEY              : ac(cc).key   = %VK_F1    : ac(cc).cmd  = %IDT_Help     : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key   = %VK_F     : ac(cc).cmd  = %IDT_Font     : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key   = %VK_N     : ac(cc).cmd  = %IDT_Clear    : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key   = %VK_O     : ac(cc).cmd  = %IDT_Open     : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key   = %VK_R     : ac(cc).cmd  = %IDT_Reload   : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key   = %VK_S     : ac(cc).cmd  = %IDT_Sort     : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key   = %VK_U     : ac(cc).cmd  = %IDT_Unique   : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key   = %VK_W     : ac(cc).cmd  = %IDT_Extract  : Incr cc
   Accel Attach hDlg, AC() To hAccelerator
End Sub

Function NewProc(ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Local x,y As Long
   Select Case Msg
      Case %WM_ContextMenu
         SetFocus wParam
         x = Lo(Integer,lParam) : y = Hi(Integer, lParam)    'WM_ContextMenu returns xy coordinates of mouse
         TrackPopupMenu hContext, %TPM_LeftAlign, x, y, 0, hDlg, ByVal 0   'put context menu where mouse is
         Function = 0 : Exit Function
   End Select
   Function = CallWindowProc(OldProc, hWnd, Msg, wParam, lParam)
End Function

Sub CreateCustomContextMenu
   Menu New PopUp To hContext
   Menu Add String, hContext, "Cut",    %IDM_Cut,  %MF_Enabled
   Menu Add String, hContext, "Copy",   %IDM_Copy,  %MF_Enabled
   Menu Add String, hContext, "Paste",  %IDM_Paste,  %MF_Enabled
   Menu Add String, hContext, "Delete", %IDM_Delete,  %MF_Enabled
   Menu Add String, hContext, "-",    %IDM_Sep,  %MF_Enabled
   Menu Add String, hContext, "Clear", %IDM_Delete,  %MF_Enabled
   Menu Add String, hContext, "CopyAll", %IDM_Delete,  %MF_Enabled
End Sub
